<?php
################################################################################
# @Name : procedure_subcat.php
# @Description : send subcat of current selected category
# @Call : ./ticket.php
# @Parameters :  
# @Author : Flox
# @Create : 30/09/2021
# @Update : 30/09/2021
# @Version : 3.2.17
################################################################################

//db connection
require('../core/functions.php');

//security check
if(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest') 
{
    //db connection
    require('../connect.php');
    
    //init and secure POST var
    require('../core/init_post.php');

    //switch SQL MODE to allow empty values
    $db->exec('SET sql_mode = ""');

    //load parameters table
    $qry=$db->prepare("SELECT * FROM `tparameters`");
    $qry->execute();
    $rparameters=$qry->fetch();
    $qry->closeCursor();

    //display error parameter
    if($rparameters['debug']) 
    {
        ini_set('display_errors', 'On'); ini_set('display_startup_errors', 'On');ini_set('html_errors', 'On');error_reporting(E_ALL);
    } else {
        ini_set('display_errors', 'Off');ini_set('display_startup_errors', 'Off');ini_set('html_errors', 'Off'); error_reporting(E_ALL & ~E_DEPRECATED & ~E_STRICT);
    }

    //init string
    $subcat_arr=array();

    //put each db value in array 
    $qry=$db->prepare("SELECT `id`,`name` FROM `tsubcat` WHERE `cat`=:id ORDER BY `name`");
    $qry->execute(array('id' => $_POST['CategoryId']));
    while($subcat=$qry->fetch()) 
    {
       $subcat_arr[] = array("id" => $subcat['id'], "name" => $subcat['name']);
    }
    $qry->closeCursor();
    //return array
    echo json_encode($subcat_arr);

    //close database access
	$db = null;
} else {
	echo json_encode('ERROR : Unauthorized access');
    logit('security','Unauthorized access on ajax/procedure_subcat.php',0);
}
?>